=== debian/changelog ===
aflplusplus (2.60c-1build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:12:03 +0100

aflplusplus (2.60c-1build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 05:40:05 +0000

aflplusplus (2.60c-1) unstable; urgency=medium

  * Team upload
  * New upstream version 2.60c
  * Remove one patch merged upstream
  * Stop cleaning what upstream cleans for us now
  * Fix version of clang dependency
  * Update patch to cover another llvm-config invocation
  * Run tests at build time
  * Disable build log scanner until #948009 is fixed
  * Fix autopkgtests

 -- Raphaël Hertzog <hertzog@debian.org>  Fri, 03 Jan 2020 11:21:35 +0100

aflplusplus (2.59c-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.4.1
  * Add new patch to support lack of unicorn_mode/unicorn directory
  * Remove binary file created by make clean (duh!)
  * Switch to clang 9.
  * Add a new patch fixing the build of libdislocator
  * Fix path of documentation files to install
  * Enable python 3 support

 -- Raphaël Hertzog <raphael@offensive-security.com>  Mon, 30 Dec 2019 14:12:46 +0100

aflplusplus (2.53c-1) unstable; urgency=medium

  [ Raphaël Hertzog ]
  * Team upload.
  * Fix Vcs-Git and Vcs-Browser URLs.
  * Note for ftpmasters: the source package contains a number of binary-only
    files in the "testcases" and "docs/vuln_samples/" subdirectories. We
    believe that they are their own sources as they have been manually crafted
    to meet specific requirements. Those files were already part of the former
    "afl" package that recently got removed. Thank you.

  [ Sophie Brun ]
  * Initial releases (Closes: #934964)
  * Add more info in patches

 -- Raphaël Hertzog <hertzog@debian.org>  Tue, 17 Sep 2019 10:52:07 +0200
