=== debian/control ===
Source: aflplusplus
Section: devel
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Sophie Brun <sophie@offensive-security.com>
Build-Depends:
 clang-9,
 debhelper-compat (= 12),
 dh-buildinfo,
 llvm-9-dev,
 python3-dev
Standards-Version: 4.4.1
Homepage: https://github.com/vanhauser-thc/AFLplusplus
Vcs-Git: https://salsa.debian.org/pkg-security-team/aflplusplus.git
Vcs-Browser: https://salsa.debian.org/pkg-security-team/aflplusplus

Package: afl++
Architecture: any
Depends:
 build-essential,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 afl++-clang,
 afl++-doc
Suggests:
 gnuplot
Conflicts: afl
Description: instrumentation-driven fuzzer for binary formats
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary. This substantially
 improves the functional coverage for the fuzzed code. The compact synthesized
 corpora produced by the tool are also useful for seeding other, more labor- or
 resource-intensive testing regimes down the road.
 .
 afl++-fuzz is designed to be practical: it has modest performance
 overhead, uses a variety of highly effective fuzzing strategies, requires
 essentially no configuration, and seamlessly handles complex, real-world use
 cases - say, common image parsing or file compression libraries.
 .
 This package is a fork of the afl package that is no longer maintained.

Package: afl++-clang
Architecture: any
Depends:
 afl++ (= ${binary:Version}),
 clang-9,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 afl++-doc
Conflicts: afl-clang
Description: instrumentation-driven fuzzer for binary formats - clang support
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary.
 .
 This package provides support for the clang compiler.

Package: afl++-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends}
Recommends:
 afl++,
 afl++-clang
Description: instrumentation-driven fuzzer for binary formats - documentation
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary.
 .
 This package provides the documentation, a collection of special crafted test
 cases, vulnerability samples and experimental stuff.
